var _regeneratorRuntime = require("@babel/runtime/regenerator");
var _toConsumableArray = require("@babel/runtime/helpers/toConsumableArray");
var _asyncToGenerator = require("@babel/runtime/helpers/asyncToGenerator");
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
var UrlJoin = require("url-join");
var HttpClient = require("./HttpClient");
var UUID = require("uuid").v4;
var _require = require("./Validation"),
  ValidateParameters = _require.ValidateParameters;
var ContentObjectAudit = {
  AuditContentObject: function AuditContentObject(_ref) {
    return _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
      var client, libraryId, objectId, versionHash, salt, samples, _ref$live, live, authorizationToken, queryParams, uris, httpClient, path, responses, auditHash, verified, audits, _iterator, _step, response, url, audit, res;
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            client = _ref.client, libraryId = _ref.libraryId, objectId = _ref.objectId, versionHash = _ref.versionHash, salt = _ref.salt, samples = _ref.samples, _ref$live = _ref.live, live = _ref$live === void 0 ? false : _ref$live, authorizationToken = _ref.authorizationToken;
            if (!salt) {
              salt = client.utils.B64(UUID());
            }
            if (!samples) {
              samples = [Math.random() * 0.33, Math.random() * 0.33 + 0.33, Math.random() * 0.33 + 0.66];
            }

            // Ensure only a max of 3 samples
            samples = samples.slice(0, 3);
            if (versionHash) {
              objectId = client.utils.DecodeVersionHash(versionHash).objectId;
            }
            if (libraryId) {
              _context.next = 9;
              break;
            }
            _context.next = 8;
            return client.ContentObjectLibraryId({
              objectId: objectId
            });
          case 8:
            libraryId = _context.sent;
          case 9:
            ValidateParameters({
              libraryId: libraryId,
              objectId: objectId,
              versionHash: versionHash
            });
            queryParams = {
              salt: salt,
              samples: samples
            };
            if (live) {
              queryParams.now = Date.now();
            }

            // Test against the node the client is currently using, plus a batch of fresh nodes
            _context.t0 = [client.HttpClient.uris[client.HttpClient.uriIndex]];
            _context.t1 = _toConsumableArray;
            _context.next = 16;
            return client.Configuration({
              configUrl: client.configUrl,
              clientIP: client.clientIP,
              region: client.region
            });
          case 16:
            _context.t2 = _context.sent.fabricURIs;
            _context.t3 = (0, _context.t1)(_context.t2);
            uris = _context.t0.concat.call(_context.t0, _context.t3).filter(function (v, i, s) {
              return s.indexOf(v) === i;
            });
            httpClient = new HttpClient({
              uris: uris
            });
            path = UrlJoin("qlibs", libraryId, "q", versionHash || objectId, live ? "call/live/audit" : "audit");
            _context.t4 = httpClient;
            if (!authorizationToken) {
              _context.next = 26;
              break;
            }
            _context.t5 = {
              Authorization: "Bearer ".concat(authorizationToken)
            };
            _context.next = 29;
            break;
          case 26:
            _context.next = 28;
            return client.authClient.AuthorizationHeader({
              libraryId: libraryId,
              objectId: objectId,
              versionHash: versionHash
            });
          case 28:
            _context.t5 = _context.sent;
          case 29:
            _context.t6 = _context.t5;
            _context.t7 = queryParams;
            _context.t8 = path;
            _context.t9 = {
              headers: _context.t6,
              queryParams: _context.t7,
              method: "GET",
              path: _context.t8
            };
            _context.next = 35;
            return _context.t4.RequestAll.call(_context.t4, _context.t9);
          case 35:
            responses = _context.sent;
            audits = [];
            _iterator = _createForOfIteratorHelper(responses);
            _context.prev = 38;
            _iterator.s();
          case 40:
            if ((_step = _iterator.n()).done) {
              _context.next = 57;
              break;
            }
            response = _step.value;
            url = new URL(response.url);
            audit = {
              host: url.hostname
            };
            if (response.ok) {
              _context.next = 49;
              break;
            }
            audit.error = response;
            audit.errorMessage = response.message || JSON.stringify(response);
            _context.next = 54;
            break;
          case 49:
            _context.next = 51;
            return client.utils.ResponseToJson(response);
          case 51:
            res = _context.sent;
            if (auditHash === undefined) {
              auditHash = res.audit_hash;
            } else if (res.audit_hash !== auditHash) {
              verified = false;
            } else if (verified === undefined) {
              verified = true;
            }
            audit.audit_hash = res.audit_hash;
          case 54:
            audits.push(audit);
          case 55:
            _context.next = 40;
            break;
          case 57:
            _context.next = 62;
            break;
          case 59:
            _context.prev = 59;
            _context.t10 = _context["catch"](38);
            _iterator.e(_context.t10);
          case 62:
            _context.prev = 62;
            _iterator.f();
            return _context.finish(62);
          case 65:
            verified = verified || false;
            return _context.abrupt("return", {
              verified: verified,
              salt: salt,
              samples: samples,
              audits: audits
            });
          case 67:
          case "end":
            return _context.stop();
        }
      }, _callee, null, [[38, 59, 62, 65]]);
    }))();
  }
};
module.exports = ContentObjectAudit;